#ifndef EXPLOSIONS_H
#define EXPLOSIONS_H

#include <vector>
#include <QImage>
#include "../common/sources/system/cmaths.h"
#include "timer.h"
#include "monsters.h"

#define MONSTER_CLOUD_COLOR QColor(66, 68, 65)

enum EExplosions
{
    eExplo_Resurrect,
    eExplo_MonsterDie
};

class CExplosions
{
public:
    struct SExplosion
    {
        EExplosions type;
        CVec2       mapPos;
        EMonsterPos monsterPos;
        CTimer      timer;
        int         startTime;
    };

    CExplosions();
    void    add(EExplosions type, CVec2 mapPos, EMonsterPos monsterPos, int duration);
    void    update();
    void    drawExplosion(QImage* image, CVec2 mapPos, CVec2 tablePos);
    void    drawCloud(QImage* image, CVec2 mapPos, CVec2 tablePos, int row);

private:
    uint8_t getRow(SExplosion& explo);

    std::vector<SExplosion> mExploList;
};

extern CExplosions  explosions;

#endif // EXPLOSIONS_H
